---
title: Reflect.set()
slug: Web/JavaScript/Reference/Global_Objects/Reflect/set
tags:
  - ECMAScript 2015
  - JavaScript
  - Method
  - Reference
  - Reflect
---
<div>{{JSRef}}</div>

<p>The static <strong><code>Reflect.set()</code></strong> method works like setting a property on an object.</p>

<div>{{EmbedInteractiveExample("pages/js/reflect-set.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">Reflect.set(<var>target</var>, <var>propertyKey</var>, <var>value</var>[, <var>receiver</var>])
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>target</var></code></dt>
 <dd>The target object on which to set the property.</dd>
 <dt><code><var>propertyKey</var></code></dt>
 <dd>The name of the property to set.</dd>
 <dt><code><var>value</var></code></dt>
 <dd>The value to set.</dd>
 <dt><code><var>receiver</var></code> {{optional_inline}}</dt>
 <dd>The value of <code>this</code> provided for the call to <code><var>target</var></code> if a setter is encountered.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Boolean")}} indicating whether or not setting the property was successful.</p>

<h3 id="Exceptions">Exceptions</h3>

<p>A {{jsxref("TypeError")}}, if <code><var>target</var></code> is not an {{jsxref("Object")}}.</p>

<h2 id="Description">Description</h2>

<p>The <code>Reflect.set</code> method allows you to set a property on an object. It does property assignment and is like the <a href="/en-US/docs/Web/JavaScript/Reference/Operators/Property_Accessors">property accessor</a> syntax as a function.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_Reflect.set">Using Reflect.set()</h3>

<pre class="brush: js notranslate">// Object
let obj = {}
Reflect.set(obj, 'prop', 'value')  // true
obj.prop  // "value"

// Array
let arr = ['duck', 'duck', 'duck']
Reflect.set(arr, 2, 'goose')  // true
arr[2]  // "goose"

// It can truncate an array.
Reflect.set(arr, 'length', 1)  // true
arr  // ["duck"]

// With just one argument, propertyKey and value are "undefined".
let obj = {}
Reflect.set(obj)  // true
Reflect.getOwnPropertyDescriptor(obj, 'undefined')
// { value: undefined, writable: true, enumerable: true, configurable: true }
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-reflect.set', 'Reflect.set')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.Reflect.set")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Reflect")}}</li>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Operators/Property_Accessors">Property accessors</a></li>
</ul>
